/* 
   
   Geeks Artificial Neural Network (G.A.N.N) - Main File
  
   Copyright GNU/GPL 2006 George Delaportas (qtgeo)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

*/



//Include Libraries - Functions - Classes
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include "gglobal.cpp"
#include "gsleep.cpp"
#include "grand.cpp"
#include "gsocket.cpp"
#include "gneuron.cpp"
#include "gstat.cpp"
#include "gerrc.cpp"
#include "ggendata.cpp"
#include "greaddata.cpp"
#include "gsavedata.cpp"
#include "gremdata.cpp"
#include "gnmopt.cpp"
#include "gsnmc.cpp"
#include "gnms.cpp"
#include "gumsgs.cpp"



//Main Function
int main(int argc,char **argv)

{

    //Variables
    int i;			//A Counter
    float Data[5];		//Real Data
    
    printf("-------------------------\n");
    printf("******   G.A.N.N   ******\n");
    printf("-------------------------\n");
    printf("=========================\n");
    printf("Copyright GNU/GPL 2006\n");
    printf("George Delaportas\n");
    printf("Dimitris Vlachos\n");
    printf("=========================\n\n");
    printf("Please Select An Option\n");
    printf("1.Create A New Neural Net\n");
    printf("2.Simulate An Existing Neural Net\n");
    printf("3.Create A New Neural Net And Simulate It\n");
    printf("4.Exit\n");
    printf("Choice:");
    
    scanf("%i",&i);
    
    printf("\n");
    
    //Check Choices
    if (i==1)
    
    {
    
        //Create GSockets And GMap
        GSNMC();
    
    }
    
    else if (i==2)
    
    {
    
        printf("Generating Random Data...\n");
        printf("Please Stand By!\n");
        
        //Get Random Generated Data
        for (i=0;i<5;i++)
            Data[i]=GGenData(1,33);
        
        printf("Done\n");
        printf("Starting Simulation...\n\n");
        
        //Halt (Very Usefull For Better Randomization - Use After GGenData)
        GSleep(1);
        
        //Simulate The G.A.A.N At Learning Mode (Hybrid Simulation Mode)
        //GNMS(Data,2);
        
        //Simulate The G.A.N.N At Running Mode
        //GNMS(Data,2);
    
    }
    
    else if (i==3)
    
    {
    
        //Create GSockets And GMap
        GSNMC();
        
        printf("Generating Random Data...\n");
        printf("Please Stand By!\n");
        
        //Get Random Generated Data
        for (i=0;i<5;i++)
            Data[i]=GGenData(1,33);
        
        printf("Done\n");
        printf("Starting Simulation...\n");
        
        GSleep(1);
        
        //Learning Mode
        //GNMS(Data,2);
        
        //Running Mode
        //GNMS();
    
    }
    
    else if (i==4)
    
    {
    
        printf("Thank You For Using G.A.N.N\n");
        printf("Goodbye!\n");
        
        exit(0);
    
    }
    
    else
    
    {
    
        printf("Error: Wrong Choice Specified!\n");
        
        exit(1);
    
    }
    
    exit(0);

}

/* ------------------------------------------------------------------------ */
