/* 
   
   Geeks Artificial Neural Network (G.A.N.N) - Error Correction
  
   Copyright GNU/GPL 2006 George Delaportas (qtgeo)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

*/



//Geeks Neurons Error Correction (Function)
void GErrC(GNeuron GANN[MAX_GN],int GNNum,float Err,int CheckType)

{

    //Variables
    int NFuncType;		//Neuron Function Type
    float NFBase;		//Neuron Function Base
    float NeuronSum;		//Neuron Summary
    unsigned int e;		//Random Values Variable
    
    //Reset NFuncType
    NFuncType=-1;
    
    //Get Neuron Function Type
    NFuncType=GANN[GNNum].GetNFT();
    
    //Check NFuncType
    if (NFuncType==0)
    
    {
    
        //Get Neuron Function Base
        NFBase=GANN[GNNum].GetBase();
        NeuronSum=GANN[GNNum].GetSum();
        
        if (NeuronSum>NFBase)
        
        {
        
            //Statistically Weighted Neurons
            if (CheckType==0)
            
            {
            
                //Random e
                if (Err<=25.0)
                    e=rand()%(int)Err;
                else
                    e=rand()%(int)(50.0-Err+1);
            
                //Make Summary Smaller Than NFunc Base (Output:0)
                GANN[GNNum].Mod=e;
            
            }
            
            //Statically Weighted Neurons
            else if (CheckType==1)
            
            {
            
                //Make Summary Smaller Than NFunc Base (Output:0)
                GANN[GNNum].Mod=1;
            
            }
            
            else
            
            {
            
                printf("Error: Wrong Check Type Specified!\n");
                
                exit(1);
            
            }
            
            //Zero Mod Check
            if (GANN[GNNum].Mod==0)
                GANN[GNNum].Mod=8;
        
        }
        
        else
        
        {
        
            //Statistically Weighted Neurons
            if (CheckType==0)
            
            {
            
                //Random e
                if (Err>=25.0)
                    e=rand()%(int)Err;
                else
                    e=rand()%(int)(100.0-Err);
            
                //Make Summary Bigger Than NFunc Base (Output:1)
                GANN[GNNum].Mod=e;
            
            }
            
            //Statically Weighted Neurons
            else if (CheckType==1)
            
            {
            
                //Make Summary Bigger Than NFunc Base (Output:1)
                GANN[GNNum].Mod=128;
            
            }
            
            else
            
            {
            
                printf("Error: Wrong Check Type Specified!\n");
                
                exit(1);
            
            }
            
            //Zero Mod Check
            if (GANN[GNNum].Mod==0)
                GANN[GNNum].Mod=8;
        
        }
    
    }
    
    else if (NFuncType==1)
    
    {
    
    
    
    }
    
    else if (NFuncType==2)
    
    {
    
    
    
    }

}

/* ------------------------------------------------------------------------ */
